#!/bin/sh
set -x

start_xserver() {
	n=100
	while [ -e /tmp/.X"$n"-lock ] ; do
		n=$[ $n + 1 ]
	done
	touch /tmp/.X"$n"-lock
	xauth add :$n MIT-MAGIC-COOKIE-1 "`dd if=/dev/urandom bs=32 count=1 2>/dev/null | md5sum | cut -f1 -d' '`"
	Xvfb -nolisten tcp :$n >/dev/null &
	echo $n
}

(
set -e

. config.sh

tmp="`tempfile -d/tmp -s.doc`"
cat >"$tmp"

cd "$WINEPREFIX/fake_windows"

DOCPDF_DESTPIPE="`tempfile`"
rm -f "$DOCPDF_DESTPIPE"
mkfifo -m0600 "$DOCPDF_DESTPIPE"
export DOCPDF_DESTPIPE

authtmp="`tempfile`"
if [ "$DOCPDF_USE_DISPLAY" = "" ] ; then
	XAUTHORITY="$authtmp"
	export XAUTHORITY

	DISPLAY=:`start_xserver`
	export DISPLAY
fi

xmessage 'nothing' & # hold open the X server
wine 'C:\Program Files\WordView\WORDVIEW.EXE' "X:\\`basename $tmp`" >/dev/null & winepid=$!
python "$LIBPREFIX"/sendkeys.py >&2 &

cat "$DOCPDF_DESTPIPE"

rm -f "$DOCPDF_DESTPIPE"

rm "$tmp"
rm "`dirname "$tmp" `/`basename "$tmp" | perl -p -e 's/^../~\\$/'`"  || true # Wordview creates junk backups
rm "$authtmp"

if [ "$DOCPDF_SETUP_METRICS" != "" ] ; then
	rm -f "$WINEPREFIX/cachedmetrics"
	mv "$WINEPREFIX/cachedmetrics.$DISPLAY.0" "$WINEPREFIX/cachedmetrics"
fi

)

# Tell stopafter to clean up this ugly mess
kill -HUP $PPID
while true ; do sleep 10 ; done
